#ifndef DEVICE_SERVICE_H
#define DEVICE_SERVICE_H

#ifdef _MSC_VER
#pragma once
#endif

#include "DeviceServiceEnums.h"
#include "ServiceCallParams.h"

namespace P1 {
namespace CamLoad {
    // Forward declaration
    namespace ServiceCall {
        class Params;
    }

    //
    class ServiceInterface
    {
    public:
        virtual EnumDeviceServiceType type() const = 0;
        virtual const ServiceCall::STRW& name() const = 0;
        virtual void perform(ActionID /*action*/, const ServiceCall::Params& /*params*/) = 0;
        virtual ServiceCall::TypeSafeParams paramsForAction(ActionID /*action*/) = 0;
    protected:
        virtual ~ServiceInterface() {}
    };
    
} //ns CamLoad
} //ns P1

#endif //DEVICE_SERVICE_H
