#ifndef DEVICE_SERVICE_ENUMS_H
#define DEVICE_SERVICE_ENUMS_H

/*	// Disabled #pragma once , the header needs to be included multiple times
#ifdef _MSC_VER
#pragma once
#endif
*/

/////////////////////////////////////////////////////////////////////////////
// cross-platform defines

#if defined(__cplusplus_cli) && defined(P1_CAMLOAD_DOTNET_ENUM)
#define P1_PUBLIC_ENUM      public enum class
#define P1_ENUM_TYPEDEF(e)
#else
#define P1_PUBLIC_ENUM      enum
#define P1_ENUM_TYPEDEF(e)  typedef enum e e;
#endif

/////////////////////////////////////////////////////////////////////////////

#if (defined(__cplusplus) || defined(__cplusplus_cli)) && !defined(__OBJC__)

namespace P1 {
namespace CamLoad {

#if defined P1_CAMLOAD_DOTNET_ENUM
namespace Enums {
#endif // P1_CAMLOAD_DOTNET_ENUM

#endif		
	
/////////////////////////////////////////////////////////////////////////////	
	
	//-------------------------
	// Services 
	//-------------------------
	P1_PUBLIC_ENUM EnumDeviceServiceType
	{
		iX_DEVICE_SERVICE_FP_SHUTTER		= 0, // Maintenance FP shutter
	};
	P1_ENUM_TYPEDEF(EnumDeviceServiceType);
        
    typedef unsigned short ServiceID;

  //-------------------------
  // Services
  //-------------------------
  P1_PUBLIC_ENUM EnumDeviceServiceAction
  {
    //<iX_DEVICE_SERVICE_FP_SHUTTER actions>
    iX_DEVICE_SERVICE_FP_SHUTTER_ACTION_UPLOAD_PARAMS    = 0,     // Upload FP shutter parameters
    iX_DEVICE_SERVICE_FP_SHUTTER_ACTION_GET_FILE_SERIAL  = 1      // Get serial number of the shutter to which the parameters in the file belong
    //</iX_DEVICE_SERVICE_FP_SHUTTER actions>
    
  };
  P1_ENUM_TYPEDEF(EnumDeviceServiceAction);
  typedef unsigned short ActionID;
/////////////////////////////////////////////////////////////////////////////

#if (defined(__cplusplus) || defined(__cplusplus_cli)) && !defined(__OBJC__)

#if defined P1_CAMLOAD_DOTNET_ENUM
} // ns Enums
#endif // P1_CAMLOAD_DOTNET_ENUM

} //namespace CamLoad
} //namespace P1
#endif

/////////////////////////////////////////////////////////////////////////////

// cleanup local defines
#undef P1_PUBLIC_ENUM
#undef P1_ENUM_TYPEDEF

/////////////////////////////////////////////////////////////////////////////

#endif //DEVICE_SERVICE_ENUMS_H
